/* JSGalBuilder: (c) 2009 by Andreas S. Krebs
 * 
 * This file is part of JSGalBuilder.
 *
 * JSGalBuilder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * JSGalBuilder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JSGalBuilder.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sberk.jsgal.datamodel;

public final class ConvUtils
{
	public final static String	NULL		="null"; //$NON-NLS-1$

	public static int parseInteger(String s, int def)
	{
		int	i=def;
		
		try
		{
			if(s!=null && s.length()>0)
				i=Integer.parseInt(s);
		}
		catch(Exception e)
		{
			// nothing to be done here
		}
		
		return i;
	}
	
	public static float parseFloat(String s, float def)
	{
		float	f=def;
		
		try
		{
			if(s!=null && s.length()>0)
				f=Float.parseFloat(s);
		}
		catch(Exception e)
		{
			// nothing to be done here
		}
		
		return f;
	}
	
	public static int parseNullInteger(String s, int def)
	{
		int	i=def;
		
		try
		{
			if(s!=null && s.length()>0)
			{
				if(s.equalsIgnoreCase(NULL))
					i=-1;
				else
					i=Integer.parseInt(s);
			}
		}
		catch(Exception e)
		{
			// nothing to be done here
		}
		
		return i;
	}
	
	public static String int2String(int i)
	{
		return Integer.toString(i);
	}
	
	
	public static String float2String(float f)
	{
		return Float.toString(f);
	}	
	
	public static String nullInt2String(int i)
	{
		if(i<0)
			return NULL;
		
		return Integer.toString(i);
	}
}
