/* JSGalBuilder: (c) 2009 by Andreas S. Krebs
 * 
 * This file is part of JSGalBuilder.
 *
 * JSGalBuilder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * JSGalBuilder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JSGalBuilder.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sberk.jsgal.gui;

import java.net.URL;
import java.util.ArrayList;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;

@SuppressWarnings("nls")
public final class I18N
{
	public final static String	JSGB			="JSGalBuilder";
	public final static String	JSGB_VERSION	="v0.5";
	public final static String	JSGB_TITLE		=JSGB+" "+JSGB_VERSION;

	public final static String	EMPTY_STRING	="";
	
	// the following strings are used to create actions 
	public final static String	MENU_FILE[]			={ "File", "f" };
	public final static String	MENU_FILE_NEW_PROJ[]		={ "New Project", "n", "document-new.png" };
	public final static String	MENU_FILE_OPEN_PROJ[]		={ "Open Project", "o", "document-open.png" };
	public final static String	MENU_FILE_UPGRADE_PROJ[]	={ "Upgrade Project", "u", "system-software-update.png" };
	
	public final static String	MENU_FILE_CLOSE[]		={ "Close", "c" , "tab-close-other.png" };
	public final static String	MENU_FILE_CLOSE_ALL[]	={ "Close All", "l" };

	public final static String	MENU_FILE_SAVE[]		={ "Save", "s", "document-save.png" };
	public final static String	MENU_FILE_SAVE_ALL[]	={ "Save All", "e", "document-save-all.png" };
	
	public final static String	MENU_FILE_EXIT[]		={ "Exit", "x", "application-exit.png" };
	
	public final static String	MENU_EDIT[]		={ "Edit", "e" };
	public final static String	MENU_EDIT_BROWSER[]	={ "Open In Browser", "b", "internet-web-browser.png" };
	public final static String	MENU_EDIT_PREF[]	={ "Preferences", "p", "preferences-system.png" };
	
	public final static String	MENU_HELP[]		={ "Help", "h" };
	public final static String	MENU_HELP_CONTENTS[]	={ "Help Contents", "c", "help-contents.png" };
	public final static String	MENU_HELP_ABOUT[]		={ "About "+JSGB, "a", "help-about.png" };
	
	public final static String	ABOUT_TITLE		="About "+JSGB;
	public final static String	ABOUT_MESSAGE	="<html><h1>"+JSGB_TITLE+"</h1><h2>A Gallery Builder for JSGal</h2>"+
												 "<h3>Copyright \u00a9 2009 by Andreas S. Krebs</h3><br>"+
												 "Visit: <a href=\"http://www.sberk.net/jsgal/builder\">http://www.sberk.net/jsgal</a><br>"+
												 "Email: <a href=\"mailto:jsgal@sberk.net\">jsgal@sberk.net</a><br><br><br>"+
												 "<b>Embedded Projects:</b><br>" +
												 "&nbsp;&nbsp;-<a href=\"http://www.sberk.net/jsgal\">{0}</a><br>" +
												 "&nbsp;&nbsp;-<a href=\"http://www.drewnoakes.com/code/exif/\">Metadata Extractor v2.3.1</a><br>" +
												 "&nbsp;&nbsp;-Icons from KDE''s <a href=\"http://www.oxygen-icons.org/\">Oxygen Icon Theme</a><br>" +
												 "<br></html>";

	public final static String	DOCS_TITLE		="Help Contents";
	
	public final static String	FILE_CHOOSER_SELECT[]	={ "Select", "s", "Select file" };
	public final static String	FILE_CHOOSER_SAVE[]		={ "Save As", "s", "Save As selected file" };
	public final static String	FILE_CHOOSER_OPEN[]		={ "Open", "o", "Open selected file" };
	public final static String	FILE_CHOOSER_ADD[]		={ "Add", "a" , "Add selected files" };
	
	public final static String	NEW_PROJECT_TITLE		="New Project";
	public final static String	NEW_PROJECT_MSG			="Enter a name for the new gallery project:";
	public final static String	NEW_PROJECT_CREATEGAL	="Create default gallery for new project";
	public final static String	NEW_PROJECT_SAVETITLE	="Select XHTML file for saving new project";

	public final static String	OPEN_PROJECT_OPENTITLE	="Select XHTML file for opening project";
	
	public final static String	NEW_GALLERY_TITLE		="New Gallery";
	public final static String	NEW_GALLERY_MSG			="Enter a name for the new gallery:";
	public final static String	NEW_GALLERY_AUTOSAVE	="Save gallery to a new file in the project folder";
	public final static String	NEW_GALLERY_ADDIMGS		="Open add images dialog for new gallery";
	public final static String	NEW_GALLERY_SAVETITLE	="Select directory and XML file for saving new gallery";

	public final static String	ADD_GALLERY_OPENTITLE	="Select XML file for adding gallery";
	
	public final static String	DIALOG_GALCOL_MOVE_UP[]			= { "Move Gallery Up", null, "arrow-up.png" };
	public final static String	DIALOG_GALCOL_MOVE_DOWN[]		= { "Move Gallery Down", null, "arrow-down.png" };
	public final static String	DIALOG_GALCOL_OPEN[]			= { "Load Gallery", null, "document-open-remote.png" };
	public final static String	DIALOG_GALCOL_ADD_NEW[]			= { "Add New Gallery", null, "document-new-from-template.png" };
	public final static String	DIALOG_GALCOL_ADD_EXISTING[]	= { "Add Existing Gallery", null, "document-import.png" };
	public final static String	DIALOG_GALCOL_REMOVE[]			= { "Remove Gallery", null, "list-remove.png" };
	
	public final static String	DIALOG_GALCOL_TITLE			="Title:";
	public final static String	DIALOG_GALCOL_JSGALVERSION	="JSGal Version Info:";
	public final static String	DIALOG_GALCOL_GALS_FILE		="Galleries File:";
	public final static String	DIALOG_GALCOL_GALRENDERING	="Gallery Selection Rendering";
	public final static String	DIALOG_GALCOL_INITIALGAL	="Initial Gallery Selection";
	public final static String	DIALOG_GALCOL_RESTORE_GAL	="Restore last shown Gallery instead of default";
	public final static String	DIALOG_GALCOL_RESTORE_IMG	="Restore last shown Image instead of default";
	public final static String	DIALOG_GALCOL_DEFIMG		="Default Image #:";
	public final static String	DIALOG_GALCOL_GALSEL_ORIENT	="Gallery Selection Orientation:";
	public final static String	ORIENT_VERT		="Vertical";
	public final static String	ORIENT_HORIZ	="Horizontal";
	public final static String	DIALOG_GALCOL_GALSINROW		="Galleries in Horizontal Row:";
	public final static String	DIALOG_GALCOL_WRAPGALLERIES	="Wrap Galleries in Slideshow";
	public final static String	DIALOG_GALCOL_GALLERIES_GROUP	="Galleries";
	
	public final static String	COLUMN_GALLERY_DEFAULT	="Default";
	public final static String	COLUMN_GALLERY_FILE		="Link";
	public final static String	COLUMN_GALLERY_TITLE	="Name";

	public final static String	DIALOG_GALLERY_TITLE		="Title:";
	
	public final static String	DIALOG_GALLERY_IMAGES_DIR	="Images Location:";	
	public final static String	DIALOG_GALLERY_THUMBS_DIR	="Thumbs Location:";	
	public final static String	DIALOG_GALLERY_DEF_IMG_SCALEING		="Default Image Scaling:";	
	public final static String	SCALE_DEFAULT	="Gallery Default";
	public final static String	SCALE_HORIZ		="Horizontal (Keep Aspect)";
	public final static String	SCALE_VERT		="Vertical (Keep Aspect)";
	public final static String	SCALE_BOTH		="Horizontal & Vertical";

	public final static String	DIALOG_GALLERY_MOVE_UP[]	= { "Move Images Up", null, "arrow-up.png" };
	public final static String	DIALOG_GALLERY_MOVE_DOWN[]	= { "Move Images Down", null, "arrow-down.png" };
	public final static String	DIALOG_GALLERY_ADD[]		= { "Add Images", null, "insert-image.png" };
	public final static String	DIALOG_GALLERY_REMOVE[]		= { "Remove Images", null, "list-remove.png" };

	public final static String	DIALOG_GALLERYPOPUP_MOVE_UP[]	= { "Move Image Up", null, "arrow-up.png" };
	public final static String	DIALOG_GALLERYPOPUP_MOVE_DOWN[]	= { "Move Image Down", null, "arrow-down.png" };
	public final static String	DIALOG_GALLERYPOPUP_REMOVE[]	= { "Remove Image", null, "list-remove.png" };
	
	public final static String	DIALOG_GALLERY_THUMB_RENDERING		="Thumbs Page Rendering";	
	public final static String	DIALOG_GALLERY_THUMB_PAGE_FIXED		="Fixed Page Size:";	
	public final static String	DIALOG_GALLERY_THUMBS				="thumbs";	
	public final static String	DIALOG_GALLERY_THUMB_PAGES_INROW	="Pages In Selection Row:";
	public final static String	DIALOG_GALLERY_THUMB_SIZE			="Thumb Size:";	
	public final static String	DIALOG_GALLERY_X					="x";	
	public final static String	DIALOG_GALLERY_PIXEL				="pixel";	
	public final static String	DIALOG_GALLERY_IMAGE_PREVIEW		="Preview Scaling:";	

	public final static String	DIALOG_GALLERY_IMAGE_RENDERING	="Image Page Rendering";	
	public final static String	DIALOG_GALLERY_IMAGE_SIZE		="Image Size:";	
	public final static String	DIALOG_GALLERY_HREF_TARGET		="Link Target For Original:";	

	public final static String	DIALOG_GALLERY_GENERAL		="General";	
	public final static String	DIALOG_GALLERY_IMAGES		="Images";	
	public final static String	DIALOG_GALLERY_PREVIEW_SEL	="Preview:";
	public final static String	PREVIEW_OFF		="Off";
	public final static String	PREVIEW_THUMB	="Thumb";
	public final static String	PREVIEW_IMAGE	="Image";
	public final static String	DIALOG_GALLERY_PREVIEW_OPTS[]	=	{PREVIEW_OFF, PREVIEW_THUMB, PREVIEW_IMAGE};
	
	public final static String	DIALOG_GALIMG_DETAILS	="Image Details:";
	public final static String	DIALOG_GALIMG_NAME		="Name:";
	public final static String	DIALOG_GALIMG_DESCR		="Description:";
	public final static String	DIALOG_GALIMG_FILE		="File:";
	public final static String	DIALOG_GALIMG_THUMB		="Thumb:";
	public final static String	DIALOG_GALIMG_SCALEING	="Image Scaling:";	
	
	public final static String	COLUMN_IMAGE_FILE			="File";
	public final static String	COLUMN_IMAGE_NAME			="Name";
	public final static String	COLUMN_IMAGE_DESCRIPTION	="Description";

	public final static String	DIALOG_IMGADD_TITLE		="Add Images to Gallery";	
	public final static String	DIALOG_IMGADD_DRAGMSG	="Note: You can add images by simply dragging them to the image list.";	
	public final static String	DIALOG_IMGADD_COL_HEADERS[]	={ "Image File", "Rotate", "Status" } ;

	public final static String	ROTATE_DEGREES[]={ "Auto", "None", "90\u00b0", "180\u00b0", "270\u00b0" }; 
	
	public final static String	ADD_IMAGES_ADDTITLE		="Select images to add to gallery";
	
	public final static String	DIALOG_IMGADD_FORMAT		="Image format: ";
	public final static String	DIALOG_IMGADD_QUALITY		="Image quality: ";
	public final static String	DIALOG_IMGADD_PROGRESSIVE	="Save image progressive";
	public final static String	DIALOG_IMGADD_OVERWRITE		="Overwrite existing files";
	public final static String	DIALOG_IMGADD_SCALEUP		="Scale up images (if smaller than configure size)";
	public final static String	DIALOG_IMGADD_USETIMESTAMP	="Use time stamp as: ";
	public final static String	USETIMESTAMP_NONE	="Nothing";
	public final static String	USETIMESTAMP_NAME	="Image Name";
	public final static String	USETIMESTAMP_DESCR	="Image Description";
	public final static String	USETIMESTAMP_VALUES[] = { USETIMESTAMP_NAME, USETIMESTAMP_DESCR, USETIMESTAMP_NONE };
	
	public final static String	DIALOG_IMGADD_ADD[]			= { "Add Images", null, "list-add.png" };
	public final static String	DIALOG_IMGADD_REMOVE[]		= { "Remove Images", null, "list-remove.png" };
	public final static String	DIALOG_IMGADD_START[]		= { "Start", null, "media-playback-start.png" };
	public final static String	DIALOG_IMGADD_STOP[]		= { "Stop", null, "media-playback-stop.png" };
	public final static String	DIALOG_IMGADD_CLOSE[]		= { "Close", null, "dialog-close.png" };
	public final static String	DIALOG_IMGADD_PROGGROUP	="Adding Images to Gallery";
	
	public final static String	IMGPREVIEW_TITLE				="Image Preview";
	public final static String	IMGPREVIEW_BUTTON_TOOLTIP		="Show Image";
	public final static String	IMGPREVIEW_STATUS_LOAD_ERROR	="Image Loading Failed: ";	
	public final static String	IMGPREVIEW_STATUS_LOADING		="Loading ...";	
	public final static String	IMGPREVIEW_STATUS_LOADED		="Loaded";	
	public final static String	IMGPREVIEW_STATUS_NOIMAGE		="No Image Loaded";	
	public final static String	IMGPREVIEW_TABLE_HEADERS[]		={ "Property", "Value" };	
	public final static String	IMGPREVIEW_TABLE_ROWS_LABELS[][]	={ { "File Name" }, { "File Size" },  { "Rotation" }, { "Dimensions" }, { "Timestamp" }, { "Status", IMGPREVIEW_STATUS_NOIMAGE } };	
	public static enum IMGPREVIEW_TABLE_ROWS { FILE, SIZE, ROTATION, DIM, TIME, STATUS }
	public final static String	IMGPREVIEW_ZOOM_IN[]		= { "Zoom In", null, "zoom-in.png" };
	public final static String	IMGPREVIEW_ZOOM_OUT[]		= { "Zoom Out", null, "zoom-out.png" };
	public final static String	IMGPREVIEW_ZOOM_ORIG[]		= { "Zoom 1:1", null, "zoom-original.png" };

	public final static String	PREFSDIALOG_TITLE			="Preferences";
	public final static String	PREFSDIALOG_LOOKANDFEEL		="Look And Feel:";
	public final static String	PREFSDIALOG_USESYSBROWSER	="Use System Default Browser";
	public final static String	PREFSDIALOG_BROWSER			="Web Browser:";
	public final static String	PREFSDIALOG_SELBROWSER		="Select Browser Application";
	public final static String	PREFSDIALOG_BROWSE[]		={ "Browse", null, "document-open.png" };
	
	public final static String	MESSAGE_TITLE_ERROR		="Error";
	public final static String	MESSAGE_TITLE_WARNING	="Warning";
	public final static String	MESSAGE_TITLE_INFO		="Info";
	public final static String	MESSAGE_TITLE_CONFIRM	="Confirm";
	public final static String	MESSAGE_DETAILS			="Details:";
	public final static String	MESSAGE_SHOW_DETAILS[]	={ "Details", null, "arrow-down-double.png", "Show Details" };
	public final static String	MESSAGE_HIDE_DETAILS[]	={ "Details", null, "arrow-up-double.png", "Hide Details" };
	public final static String	MESSAGE_OPT_OK[]		={ "OK", "o", "dialog-ok.png" };
	public final static String	MESSAGE_OPT_CANCEL[]	={ "Cancel", "c", "dialog-cancel.png" };
	public final static String	MESSAGE_OPT_YES[]		={ "Yes", "y", "dialog-ok.png" };
	public final static String	MESSAGE_OPT_NO[]		={ "No", "n", "edit-delete.png" };
	public final static String	MESSAGE_TITLE_SAVE_CHANGES	="Save changes";
	public final static String	MESSAGE_MSG_SAVE_CHANGES		="''{0}'' has been modified. Save changes?";
	public final static String	MESSAGE_MSG_SELECT_SAVE_CHANGES	="Select files to save:";
	public final static String	MESSAGE_NODOCS="Documentation file 'doc/index.html' is missing in distribution";
	
	public final static String		EXT_HTML="html";
	public final static String		EXT_XML="xml";
	public final static FileFilter	XHTML_FILEFILTER=new FileNameExtensionFilter("XHTML Files (*.html,*.htm,*.xhtml)", "html", "htm", "xhtml");
	public final static FileFilter	XML_FILEFILTER=new FileNameExtensionFilter("XML Files (*.xml)", "xml");
	public final static String		IMAGE_FILEFILTERNAME="Images ({0})";
	
	public final static ImageIcon	ICON_XHTML=getIcon("application-xslt+xml.png");
	public final static ImageIcon	ICON_GALLERY=getIcon("application-xhtml+xml.png");
	public final static ImageIcon	ICON_IMAGE=getIcon("image-jpeg.png");
	public final static ImageIcon	ICON_IMAGE_MISSING=getIcon("image-missing.png");
	public final static ImageIcon	ICON_DIALOG_INFO=getIcon("dialog-information.png");
	public final static ImageIcon	ICON_DIALOG_WARN=getIcon("dialog-warning.png");
	public final static ImageIcon	ICON_DIALOG_ERROR=getIcon("dialog-error.png");
	public final static ImageIcon	ICON_DIALOG_QUESTION=getIcon("system-help.png");
	public final static ImageIcon	ICON_LOCKED=getIcon("object-locked.png");
	public final static ImageIcon	ICON_BUILDER=getIcon("jsgalbuilder.png");
	
	public final static String	STATUS_INITIAL		="Initial";
	public final static String	STATUS_INPROGRESS	="In Progress";
	public final static String	STATUS_COMPLETED	="Completed";
	public final static String	STATUS_FAILED		="Failed";	
	public final static ImageIcon	ICON_INITIAL=null;
	public final static ImageIcon	ICON_PROGRESS=getIcon("system-run.png");
	public final static ImageIcon	ICON_FAILED=getIcon("mail-mark-important.png");
	public final static ImageIcon	ICON_COMPLETED=getIcon("mail-mark-notjunk.png");
	
	private I18N()
	{
		// nothing to be done here
	}
	
	public static ImageIcon getIcon(String iconname)
	{
		ImageIcon	icon=null;
		URL	u=I18N.class.getResource("resources/"+iconname);
			
		if(u!=null)
			icon=new ImageIcon(u);
		else
			System.err.println("missing icon: "+iconname);
		
		return	icon;
	}
	
	public static URL getDocURL()
	{
		return I18N.class.getResource("doc/index.html");
	}
	
	@SuppressWarnings("serial")
	public static abstract class NamedAction extends AbstractAction
	{
		public NamedAction(String name)
		{
			this(name, null);
		}
		
		public NamedAction(String name, boolean enabled)
		{
			this(name, null);
			
			setEnabled(enabled);
		}

		public NamedAction(String name, ArrayList<Action> acList)
		{
			super(name);
			
			putValue(SHORT_DESCRIPTION, name);
			
			if(acList!=null)
				acList.add(this);
		}

		public NamedAction(String names[])
		{
			this(names, null);
		}

		public NamedAction(String names[], boolean enabled)
		{
			this(names, null);
			
			setEnabled(enabled);
		}		
		
		public NamedAction(String names[], ArrayList<Action> acList)
		{
			this(names[0], acList);
			
			if(names.length>1 && names[1]!=null && names[1].length()>0)
			{
				putValue(MNEMONIC_KEY, new Integer(names[1].charAt(0)));
			}
			
			if(names.length>2 && names[2]!=null && names[2].length()>0)
			{
				ImageIcon	icon=I18N.getIcon(names[2]);
				
				if(icon!=null)
					putValue(SMALL_ICON, icon);
			}
			
			if(names.length>3 && names[3]!=null && names[3].length()>0)
			{
				putValue(SHORT_DESCRIPTION, names[3]);
			}
		}
	}	
}