/* JSGalBuilder: (c) 2009 by Andreas S. Krebs
 * 
 * This file is part of JSGalBuilder.
 *
 * JSGalBuilder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * JSGalBuilder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JSGalBuilder.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sberk.jsgal.gui;

import java.text.MessageFormat;

@SuppressWarnings("nls")
public final class I18NMsg
{
	// the known messages
	public final static I18NMsg	MSG_UPGRADE_TO_NEWER_VERSION	=
		new I18NMsg("<html>Project version ''{0}'' is lower than ''{1}'' (include with JSGalBuilder).<br><br>"+
					"<b>Do you want to upgrade the project to ''{1}''?</b></html>");
	
	public final static I18NMsg	MSG_WARNING_UPGRADE_NEWER_VERSION	=
		new I18NMsg("<html>Project version ''{0}'' is higher than ''{1}'' (include with JSGalBuilder).<br><br>"+
					"<b>Do you really want to upgrade the project to ''{1}''?</b></html>");
	
	public final static I18NMsg	MSG_CONFIRM_UPGRADE					=
		new I18NMsg("<html>The upgrade will overwrite all files belonging to the JSGal distribution.<br>"+
					"All modifications you made to them will be lost!<br>"+
					"The current project file ''{0}'' will be backuped and recreated.<br><br>"+
					"<b>Do you want to perform the upgrade now?</b></html>");
	
	public final static I18NMsg	MSG_IMAGE_FILE_ALREADY_EXISTS	=
		new I18NMsg("Image already exists: {0}");
	
	public final static I18NMsg	MSG_GALLERY_FILE_ALREADY_EXISTS	=
		new I18NMsg("Gallery file already exists: {0}");
	
	public final static I18NMsg	MSG_REF_GALLERY_LOADED			=
		new I18NMsg("Referenced gallery is still loaded!");
	
	
	// the stuff for the message class
	private	String	msg;
	
	private I18NMsg(String msg)
	{
		this.msg=msg;
	}
	
	public final String msg()
	{
		return msg;
	}
	
	public final String fmt(String ... args)
	{
		return MessageFormat.format(msg, (Object[])args);
	}
}